﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Public Class Form1

    Dim peer As Socket

    Dim receiveBuffer(512) As Byte
    Dim receiveString As String

    Private Delegate Sub DelegateSub()

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        closeConnection()

    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.gb_io.Enabled = False
        Me.bt_bindingstop.Enabled = False
        Me.sb_status.Text = "no connection"

    End Sub

    Private Sub bt_bind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_bind.Click

        If Me.ed_ip.Text <> "" And Me.ed_LocalPort.Text <> "" And Me.ed_RemotePort.Text <> "" Then
            Try

                peer = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
                Dim LocalEP As New IPEndPoint(IPAddress.Any, Val(Me.ed_LocalPort.Text))

                peer.Bind(LocalEP)

                peer.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), peer)

                sb_status.Text = "Binded"
                Me.unbindenable()
            Catch ex As Exception
                closeConnection()
                sb_status.Text = "Binding not possible"
            End Try
        Else
            sb_status.Text = "IP and Ports needed"
        End If

    End Sub

    Private Sub callback_receive(ByVal ar As IAsyncResult)

        Dim receiveCount As Integer

        Try
            If Not peer Is Nothing Then

                receiveCount = peer.EndReceive(ar)
                receiveString = Encoding.ASCII.GetString(receiveBuffer)
                Array.Clear(receiveBuffer, 0, 512)
                Me.Invoke(New DelegateSub(AddressOf evaluateResponse))
                peer.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), peer)

            End If
        Catch ex As Exception
            Me.sb_status.Text = "Error while receiving!"
        End Try

        If receiveCount = 0 Then
            closeConnection()
        End If

    End Sub

    Private Sub closeConnection()

        Try
            If Not peer Is Nothing Then

                peer.Shutdown(SocketShutdown.Both)
                peer.Close()
                peer = Nothing

            End If

            Me.sb_status.Text = "no connection"

            Me.Invoke(New DelegateSub(AddressOf bindenable))
        Catch ex As Exception
            Me.sb_status.Text = "Error while unbinding!"
        End Try

    End Sub

    Private Sub unbindenable()

        Me.bt_bindingstop.Enabled = True
        Me.bt_bind.Enabled = False
        Me.gb_io.Enabled = True

    End Sub

    Private Sub bindenable()

        Me.bt_bindingstop.Enabled = False
        Me.bt_bind.Enabled = True
        Me.gb_io.Enabled = False

    End Sub

    Private Sub evaluateResponse()

        Dim seperator() As Char = {";"}

        Try

            Select Case receiveString.Substring(0, 1)
                Case "i"
                    Dim inputValue As Integer = Convert.ToInt16(receiveString.Substring(6, 4), 16)

                    For port As Integer = 0 To 11
                        If inputValue And 2 ^ port Then
                            CType(Me.Controls.Find("cb_input" & port, True)(0), CheckBox).Checked = True
                        Else
                            CType(Me.Controls.Find("cb_input" & port, True)(0), CheckBox).Checked = False
                        End If
                    Next


                Case "o"
                    Dim outputValue As Integer = Convert.ToInt16(receiveString.Substring(7, 4), 16)

                    For port As Integer = 0 To 11
                        If outputValue And 2 ^ port Then
                            CType(Me.Controls.Find("cb_output" & port, True)(0), CheckBox).Checked = True
                        Else
                            CType(Me.Controls.Find("cb_output" & port, True)(0), CheckBox).Checked = False
                        End If
                    Next

                Case "c"
                    If receiveString.IndexOf(";") = 7 Then
                        Dim values() As String = receiveString.Split(seperator)

                        For port As Integer = 0 To 11
                            CType(Me.Controls.Find("ed_counter" & port, True)(0), TextBox).Text = values(port + 1)
                        Next
                    Else
                        Dim port As Integer = receiveString.Substring(7, receiveString.IndexOf(";") - 7)
                        Dim value As Integer = receiveString.Substring(receiveString.IndexOf(";") + 1)
                        CType(Me.Controls.Find("ed_counter" & port, True)(0), TextBox).Text = value
                    End If
            End Select

        Catch ex As Exception
            Me.sb_status.Text = "Error while receiving"
        End Try

    End Sub

    Private Sub ed_interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ed_interval.TextChanged

        Me.Timer_polling.Interval = Val(Me.ed_interval.Text)

    End Sub

    Private Sub sendCmd(ByVal cmd As String)

        Try
            Dim sendtoEP As New IPEndPoint(IPAddress.Parse(ed_ip.Text), Integer.Parse(ed_RemotePort.Text))

            Dim cmdBytes As Byte()
            cmdBytes = Encoding.ASCII.GetBytes(cmd)
            peer.SendTo(cmdBytes, 0, cmdBytes.Length, SocketFlags.None, sendtoEP)

        Catch ex As Exception
            Me.sb_status.Text = "Error while sending command!"
        End Try

    End Sub

    Private Sub cb_output_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_output0.Click, cb_output1.Click, cb_output9.Click, cb_output8.Click, cb_output7.Click, cb_output6.Click, cb_output5.Click, cb_output4.Click, cb_output3.Click, cb_output2.Click, cb_output11.Click, cb_output10.Click

        Dim Cur_cb As CheckBox = sender
        Dim CurOutputNo As Integer

        If Cur_cb.Name.Length = 10 Then
            CurOutputNo = Cur_cb.Name.Substring(9, 1)
        Else
            CurOutputNo = Cur_cb.Name.Substring(9, 2)
        End If

        If Cur_cb.Checked Then
            sendCmd("GET /outputaccess" & CurOutputNo & "?PW=" & ed_Password.Text & "&State=ON&")
        Else
            sendCmd("GET /outputaccess" & CurOutputNo & "?PW=" & ed_Password.Text & "&State=OFF&")
        End If

    End Sub

    Private Sub bt_outputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_outputs_read.Click

        sendCmd("GET /output?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_inputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_inputs_read.Click

        sendCmd("GET /input?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_conter_readall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_conter_readall.Click

        sendCmd("GET /counter?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_counter_clearall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clearall.Click

        sendCmd("GET /counterclear?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_counter_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_read0.Click, bt_counter_read1.Click, bt_counter_read9.Click, bt_counter_read8.Click, bt_counter_read7.Click, bt_counter_read6.Click, bt_counter_read5.Click, bt_counter_read4.Click, bt_counter_read3.Click, bt_counter_read2.Click, bt_counter_read11.Click, bt_counter_read10.Click

        Dim Cur_bt As Button = sender
        Dim CurCounterNo As Integer

        If Cur_bt.Name.Length = 16 Then
            CurCounterNo = Cur_bt.Name.Substring(15, 1)
        Else
            CurCounterNo = Cur_bt.Name.Substring(15, 2)
        End If

        sendCmd("GET /counter" & CurCounterNo.ToString & "?PW=" & ed_Password.Text & "&")

    End Sub

    Private Sub bt_counter_clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clear0.Click, bt_counter_clear1.Click, bt_counter_clear4.Click, bt_counter_clear3.Click, bt_counter_clear2.Click, bt_counter_clear9.Click, bt_counter_clear8.Click, bt_counter_clear7.Click, bt_counter_clear6.Click, bt_counter_clear5.Click, bt_counter_clear11.Click, bt_counter_clear10.Click

        Dim Cur_bt As Button = sender
        Dim CurCounterNo As Integer

        If Cur_bt.Name.Length = 17 Then
            CurCounterNo = Cur_bt.Name.Substring(16, 1)
        Else
            CurCounterNo = Cur_bt.Name.Substring(16, 2)
        End If

        sendCmd("GET /counterclear" & CurCounterNo & "?PW=" & ed_Password.Text & "&")

    End Sub

    Private Sub bt_bindingstop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_bindingstop.Click

        closeConnection()

    End Sub

    Private Sub Timer_polling_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_polling.Tick

        If Not peer Is Nothing Then

            If cb_output_polling.Checked Then
                sendCmd("GET /output?PW=" + ed_Password.Text + "&")
            End If
            If cb_input_polling.Checked Then
                sendCmd("GET /input?PW=" + ed_Password.Text + "&")
            End If
            If cb_counter_polling.Checked Then
                sendCmd("GET /counter?PW=" + ed_Password.Text + "&")
            End If

        End If

    End Sub
End Class
